//Copyright (C) 2002 Microsoft Corporation
//All rights reserved.
//THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER 
//EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF 
//MERCHANTIBILITY AND/OR FITNESS FOR A PARTICULAR PURPOSE.
//Requires the Trial or Release version of Visual Studio .NET Professional (or greater).

using System;
using System.Collections;
using System.Threading;
using System.Windows.Forms;
using System.Net.Sockets;

public class frmMain : System.Windows.Forms.Form 
{

#region " Windows Form Designer generated code "

	/// <summary>
	/// The main entry point for the application.
	/// </summary>
	[STAThread]
	static void Main() 
	{
		Application.Run(new frmMain());
	}

    public frmMain() 
	{
        //This call is required by the Windows Form Designer.
        InitializeComponent();
        //Add any initialization after the InitializeComponent() call
        // So that we only need to set the title of the application once,
        // we use the AssemblyInfo class (defined in the AssemblyInfo.cs file)
        // to read the AssemblyTitle attribute.
        AssemblyInfo ainfo = new AssemblyInfo();
        this.Text = ainfo.Title;
        this.mnuAbout.Text = string.Format("&About {0} ...", ainfo.Title);
    }

    //Form overrides dispose to clean up the component list.
    protected override void Dispose(bool disposing) {
        if (disposing) {
            if (components != null) {
                components.Dispose();
            }
        }
        base.Dispose(disposing);
    }
    //Required by the Windows Form Designer
    private System.ComponentModel.IContainer components = null;
    //NOTE: The following procedure is required by the Windows Form Designer
    //It can be modified using the Windows Form Designer.  
    //Do not modify it using the code editor.
    private System.Windows.Forms.MainMenu mnuMain;

    private System.Windows.Forms.MenuItem mnuFile;

    private System.Windows.Forms.MenuItem mnuExit;

    private System.Windows.Forms.MenuItem mnuHelp;

    private System.Windows.Forms.MenuItem mnuAbout;

    private System.Windows.Forms.ListBox lstStatus;

    private System.Windows.Forms.Button btnBroadcast;

    private System.Windows.Forms.TextBox txtBroadcast;

    private System.Windows.Forms.Label lblInstructions;

    private System.Windows.Forms.Label Label1;

    private void InitializeComponent() {
        this.components = new System.ComponentModel.Container();
        System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(frmMain));
        this.mnuMain = new System.Windows.Forms.MainMenu(this.components);
        this.mnuFile = new System.Windows.Forms.MenuItem();
        this.mnuExit = new System.Windows.Forms.MenuItem();
        this.mnuHelp = new System.Windows.Forms.MenuItem();
        this.mnuAbout = new System.Windows.Forms.MenuItem();
        this.lstStatus = new System.Windows.Forms.ListBox();
        this.txtBroadcast = new System.Windows.Forms.TextBox();
        this.btnBroadcast = new System.Windows.Forms.Button();
        this.lblInstructions = new System.Windows.Forms.Label();
        this.Label1 = new System.Windows.Forms.Label();
        this.SuspendLayout();
        // 
        // mnuMain
        // 
        this.mnuMain.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.mnuFile,
            this.mnuHelp});
        // 
        // mnuFile
        // 
        this.mnuFile.Index = 0;
        this.mnuFile.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.mnuExit});
        resources.ApplyResources(this.mnuFile, "mnuFile");
        // 
        // mnuExit
        // 
        this.mnuExit.Index = 0;
        resources.ApplyResources(this.mnuExit, "mnuExit");
        this.mnuExit.Click += new System.EventHandler(this.mnuExit_Click);
        // 
        // mnuHelp
        // 
        this.mnuHelp.Index = 1;
        this.mnuHelp.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.mnuAbout});
        resources.ApplyResources(this.mnuHelp, "mnuHelp");
        // 
        // mnuAbout
        // 
        this.mnuAbout.Index = 0;
        resources.ApplyResources(this.mnuAbout, "mnuAbout");
        this.mnuAbout.Click += new System.EventHandler(this.mnuAbout_Click);
        // 
        // lstStatus
        // 
        resources.ApplyResources(this.lstStatus, "lstStatus");
        this.lstStatus.Name = "lstStatus";
        // 
        // txtBroadcast
        // 
        resources.ApplyResources(this.txtBroadcast, "txtBroadcast");
        this.txtBroadcast.Name = "txtBroadcast";
        // 
        // btnBroadcast
        // 
        resources.ApplyResources(this.btnBroadcast, "btnBroadcast");
        this.btnBroadcast.Name = "btnBroadcast";
        this.btnBroadcast.Click += new System.EventHandler(this.btnBroadcast_Click);
        // 
        // lblInstructions
        // 
        resources.ApplyResources(this.lblInstructions, "lblInstructions");
        this.lblInstructions.ForeColor = System.Drawing.Color.FromArgb(((int)(((byte)(0)))), ((int)(((byte)(0)))), ((int)(((byte)(192)))));
        this.lblInstructions.Name = "lblInstructions";
        // 
        // Label1
        // 
        resources.ApplyResources(this.Label1, "Label1");
        this.Label1.ForeColor = System.Drawing.Color.FromArgb(((int)(((byte)(0)))), ((int)(((byte)(0)))), ((int)(((byte)(192)))));
        this.Label1.Name = "Label1";
        // 
        // frmMain
        // 
        resources.ApplyResources(this, "$this");
        this.Controls.Add(this.Label1);
        this.Controls.Add(this.lblInstructions);
        this.Controls.Add(this.btnBroadcast);
        this.Controls.Add(this.txtBroadcast);
        this.Controls.Add(this.lstStatus);
        this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
        this.MaximizeBox = false;
        this.Menu = this.mnuMain;
        this.Name = "frmMain";
        this.Closing += new System.ComponentModel.CancelEventHandler(this.frmMain_Closing);
        this.Load += new System.EventHandler(this.frmMain_Load);
        this.ResumeLayout(false);
        this.PerformLayout();

	}

#endregion

#region " Standard Menu Code "

    // This code simply shows the About form.
    private void mnuAbout_Click(object sender, System.EventArgs e) 
	{
        // Open the About form in Dialog Mode
        frmAbout frm = new frmAbout();
        frm.ShowDialog(this);
        frm.Dispose();
    }

    // This code will close the form.
    private void mnuExit_Click(object sender, System.EventArgs e) 
	{
        // Close the current form
        this.Close();
    }

#endregion

    const int PORT_NUM = 10000;
    private Hashtable clients = new Hashtable();
    private TcpListener listener;
    private Thread listenerThread;

    // This subroutine sends a message to all attached clients
    private void Broadcast(string strMessage)
	{
		UserConnection client;
        // All entries in the clients Hashtable are UserConnection so it is possible
        // to assign it safely.
        foreach(DictionaryEntry entry in clients)
		{
            client = (UserConnection) entry.Value;
            client.SendData(strMessage);
        }
    }

    // This subroutine sends the contents of the Broadcast textbox to all clients, if
    // it is not empty, and clears the textbox
    private void btnBroadcast_Click(object sender, System.EventArgs e) 
	{
        if (txtBroadcast.Text != "")
		{
            UpdateStatus("Broadcasting: " + txtBroadcast.Text);
            Broadcast("BROAD|" + txtBroadcast.Text);
            txtBroadcast.Text = string.Empty;
        }
    }

    // This subroutine checks to see if username already exists in the clients 
    // Hashtable.  if it does, send a REFUSE message, otherwise confirm with a JOIN.
    private void ConnectUser(string userName, UserConnection sender)
	{
		if (clients.Contains(userName))
		{
			ReplyToSender("REFUSE", sender);
		}
		else 
		{
			sender.Name = userName;
			UpdateStatus(userName + " has joined the chat.");
			clients.Add(userName, sender);
			// Send a JOIN to sender, and notify all other clients that sender joined
			ReplyToSender("JOIN", sender);
			SendToClients("CHAT|" + sender.Name + " has joined the chat.", sender);
		}
    }

    // This subroutine notifies other clients that sender left the chat, and removes
    // the name from the clients Hashtable
    private void DisconnectUser(UserConnection sender)
	{
        UpdateStatus(sender.Name + " has left the chat.");
        SendToClients("CHAT|" + sender.Name + " has left the chat.", sender);
        clients.Remove(sender.Name);
    }

    // This subroutine is used a background listener thread to allow reading incoming
    // messages without lagging the user interface.
    private void DoListen()
	{
        try {
            // Listen for new connections.
            listener = new TcpListener(System.Net.IPAddress.Any, PORT_NUM);
            listener.Start();

			do
			{
				// Create a new user connection using TcpClient returned by
				// TcpListener.AcceptTcpClient()
				UserConnection client = new UserConnection(listener.AcceptTcpClient());
				// Create an event handler to allow the UserConnection to communicate
				// with the window.
				client.LineReceived += new LineReceive(OnLineReceived);
				//AddHandler client.LineReceived, AddressOf OnLineReceived;
				UpdateStatus("new connection found: waiting for log-in");
			}while(true);
        } 
		catch{
        }
    }

    // When the window closes, stop the listener.
    private void frmMain_Closing(object sender, System.ComponentModel.CancelEventArgs e) //base.Closing;
	{
        listener.Stop();
    }

    // Start the background listener thread.
    private void frmMain_Load(object sender, System.EventArgs e) 
	{
        listenerThread = new Thread(new ThreadStart(DoListen));
        listenerThread.Start();
        UpdateStatus("Listener started");
    }

    // Concatenate all the client names and send them to the user who requested user list
    private void ListUsers(UserConnection sender)
	{
        UserConnection client;       
        string strUserList;
        UpdateStatus("Sending " + sender.Name + " a list of users online.");
        strUserList = "LISTUSERS";
        // All entries in the clients Hashtable are UserConnection so it is possible
        // to assign it safely.

        foreach(DictionaryEntry entry in clients)
		{
            client = (UserConnection) entry.Value;
            strUserList = strUserList + "|" + client.Name;
        }

        // Send the list to the sender.
        ReplyToSender(strUserList, sender);
    }

    // This is the event handler for the UserConnection when it receives a full line.
    // Parse the cammand and parameters and take appropriate action.
    private void OnLineReceived(UserConnection sender, string data)
	{
        string[] dataArray;
        // Message parts are divided by "|"  Break the string into an array accordingly.
        dataArray = data.Split((char) 124);

        // dataArray(0) is the command.
        switch( dataArray[0])
		{
            case "CONNECT":
                ConnectUser(dataArray[1], sender);
				break;
            case "CHAT":
                SendChat(dataArray[1], sender);
				break;
            case "DISCONNECT":
                DisconnectUser(sender);
				break;
            case "REQUESTUSERS":
                ListUsers(sender);
				break;
            default: 
                UpdateStatus("Unknown message:" + data);
				break;
        }
    }

    // This subroutine sends a response to the sender.
    private void ReplyToSender(string strMessage, UserConnection sender)
	{
        sender.SendData(strMessage);
    }

    // Send a chat message to all clients except sender.
    private void SendChat(string message, UserConnection sender)
	{
        UpdateStatus(sender.Name + ": " + message);
        SendToClients("CHAT|" + sender.Name + ": " + message, sender);
    }

    // This subroutine sends a message to all attached clients except the sender.
    private void SendToClients(string strMessage, UserConnection sender)
	{
        UserConnection client;
        // All entries in the clients Hashtable are UserConnection so it is possible
        // to assign it safely.
        foreach(DictionaryEntry entry in clients)
		{
            client = (UserConnection) entry.Value;
            // Exclude the sender.
            if (client.Name != sender.Name)
			{
                client.SendData(strMessage);
            }
        }
    }

    // This subroutine adds line to the Status listbox
    private void UpdateStatus(string statusMessage)
	{
        lstStatus.Items.Add(statusMessage);
    }
}

